"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadSquaresPreset = void 0;
const plugin_emitters_1 = require("@tsparticles/plugin-emitters");
const plugin_hex_color_1 = require("@tsparticles/plugin-hex-color");
const updater_rotate_1 = require("@tsparticles/updater-rotate");
const updater_size_1 = require("@tsparticles/updater-size");
const shape_square_1 = require("@tsparticles/shape-square");
const updater_stroke_color_1 = require("@tsparticles/updater-stroke-color");
const options_js_1 = require("./options.js");
async function loadSquaresPreset(engine, refresh = true) {
    await (0, plugin_hex_color_1.loadHexColorPlugin)(engine, false);
    await (0, plugin_emitters_1.loadEmittersPlugin)(engine, false);
    await (0, shape_square_1.loadSquareShape)(engine, false);
    await (0, updater_rotate_1.loadRotateUpdater)(engine, false);
    await (0, updater_size_1.loadSizeUpdater)(engine, false);
    await (0, updater_stroke_color_1.loadStrokeColorUpdater)(engine, false);
    await engine.addPreset("squares", options_js_1.options, false);
    await engine.refresh(refresh);
}
exports.loadSquaresPreset = loadSquaresPreset;
