import { loadEmittersPlugin } from "@tsparticles/plugin-emitters";
import { loadHexColorPlugin } from "@tsparticles/plugin-hex-color";
import { loadRotateUpdater } from "@tsparticles/updater-rotate";
import { loadSizeUpdater } from "@tsparticles/updater-size";
import { loadSquareShape } from "@tsparticles/shape-square";
import { loadStrokeColorUpdater } from "@tsparticles/updater-stroke-color";
import { options } from "./options.js";
export async function loadSquaresPreset(engine, refresh = true) {
    await loadHexColorPlugin(engine, false);
    await loadEmittersPlugin(engine, false);
    await loadSquareShape(engine, false);
    await loadRotateUpdater(engine, false);
    await loadSizeUpdater(engine, false);
    await loadStrokeColorUpdater(engine, false);
    await engine.addPreset("squares", options, false);
    await engine.refresh(refresh);
}
