/*!
 * Author : Matteo Bruni
 * MIT license: https://opensource.org/licenses/MIT
 * Demo / Generator : https://particles.js.org/
 * GitHub : https://www.github.com/matteobruni/tsparticles
 * How to use? : Check the GitHub README
 * v3.2.0
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("@tsparticles/plugin-emitters"), require("@tsparticles/engine"), require("@tsparticles/updater-size"), require("@tsparticles/shape-square"), require("@tsparticles/updater-stroke-color"));
	else if(typeof define === 'function' && define.amd)
		define(["@tsparticles/plugin-emitters", "@tsparticles/engine", "@tsparticles/updater-size", "@tsparticles/shape-square", "@tsparticles/updater-stroke-color"], factory);
	else {
		var a = typeof exports === 'object' ? factory(require("@tsparticles/plugin-emitters"), require("@tsparticles/engine"), require("@tsparticles/updater-size"), require("@tsparticles/shape-square"), require("@tsparticles/updater-stroke-color")) : factory(root["window"], root["window"], root["window"], root["window"], root["window"]);
		for(var i in a) (typeof exports === 'object' ? exports : root)[i] = a[i];
	}
})(this, (__WEBPACK_EXTERNAL_MODULE__68__, __WEBPACK_EXTERNAL_MODULE__533__, __WEBPACK_EXTERNAL_MODULE__2__, __WEBPACK_EXTERNAL_MODULE__652__, __WEBPACK_EXTERNAL_MODULE__204__) => {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 533:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__533__;

/***/ }),

/***/ 68:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__68__;

/***/ }),

/***/ 652:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__652__;

/***/ }),

/***/ 2:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__2__;

/***/ }),

/***/ 204:
/***/ ((module) => {

module.exports = __WEBPACK_EXTERNAL_MODULE__204__;

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId](module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/define property getters */
/******/ 	(() => {
/******/ 		// define getter functions for harmony exports
/******/ 		__webpack_require__.d = (exports, definition) => {
/******/ 			for(var key in definition) {
/******/ 				if(__webpack_require__.o(definition, key) && !__webpack_require__.o(exports, key)) {
/******/ 					Object.defineProperty(exports, key, { enumerable: true, get: definition[key] });
/******/ 				}
/******/ 			}
/******/ 		};
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	(() => {
/******/ 		__webpack_require__.o = (obj, prop) => (Object.prototype.hasOwnProperty.call(obj, prop))
/******/ 	})();
/******/ 	
/******/ 	/* webpack/runtime/make namespace object */
/******/ 	(() => {
/******/ 		// define __esModule on exports
/******/ 		__webpack_require__.r = (exports) => {
/******/ 			if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 				Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 			}
/******/ 			Object.defineProperty(exports, '__esModule', { value: true });
/******/ 		};
/******/ 	})();
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
// ESM COMPAT FLAG
__webpack_require__.r(__webpack_exports__);

// EXPORTS
__webpack_require__.d(__webpack_exports__, {
  loadSquaresPreset: () => (/* binding */ loadSquaresPreset)
});

// EXTERNAL MODULE: external {"commonjs":"@tsparticles/plugin-emitters","commonjs2":"@tsparticles/plugin-emitters","amd":"@tsparticles/plugin-emitters","root":"window"}
var plugin_emitters_root_window_ = __webpack_require__(68);
// EXTERNAL MODULE: external {"commonjs":"@tsparticles/engine","commonjs2":"@tsparticles/engine","amd":"@tsparticles/engine","root":"window"}
var engine_root_window_ = __webpack_require__(533);
;// CONCATENATED MODULE: ../../node_modules/.pnpm/@tsparticles+plugin-hex-color@3.7.1/node_modules/@tsparticles/plugin-hex-color/browser/HexColorManager.js
var RgbIndexes;
(function (RgbIndexes) {
    RgbIndexes[RgbIndexes["r"] = 1] = "r";
    RgbIndexes[RgbIndexes["g"] = 2] = "g";
    RgbIndexes[RgbIndexes["b"] = 3] = "b";
    RgbIndexes[RgbIndexes["a"] = 4] = "a";
})(RgbIndexes || (RgbIndexes = {}));
const shorthandHexRegex = /^#?([a-f\d])([a-f\d])([a-f\d])([a-f\d])?$/i, hexRegex = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})?$/i, hexRadix = 16, defaultAlpha = 1, alphaFactor = 0xff;
class HexColorManager {
    constructor() {
        this.key = "hex";
        this.stringPrefix = "#";
    }
    handleColor(color) {
        return this._parseString(color.value);
    }
    handleRangeColor(color) {
        return this._parseString(color.value);
    }
    parseString(input) {
        return this._parseString(input);
    }
    _parseString(hexColor) {
        if (typeof hexColor !== "string") {
            return;
        }
        if (!hexColor?.startsWith(this.stringPrefix)) {
            return;
        }
        const hexFixed = hexColor.replace(shorthandHexRegex, (_, r, g, b, a) => {
            return r + r + g + g + b + b + (a !== undefined ? a + a : "");
        }), result = hexRegex.exec(hexFixed);
        return result
            ? {
                a: result[RgbIndexes.a] !== undefined
                    ? parseInt(result[RgbIndexes.a], hexRadix) / alphaFactor
                    : defaultAlpha,
                b: parseInt(result[RgbIndexes.b], hexRadix),
                g: parseInt(result[RgbIndexes.g], hexRadix),
                r: parseInt(result[RgbIndexes.r], hexRadix),
            }
            : undefined;
    }
}

;// CONCATENATED MODULE: ../../node_modules/.pnpm/@tsparticles+plugin-hex-color@3.7.1/node_modules/@tsparticles/plugin-hex-color/browser/index.js


async function loadHexColorPlugin(engine, refresh = true) {
    (0,engine_root_window_.assertValidVersion)(engine, "3.7.1");
    await engine.addColorManager(new HexColorManager(), refresh);
}

;// CONCATENATED MODULE: ../../node_modules/.pnpm/@tsparticles+updater-rotate@3.7.1/node_modules/@tsparticles/updater-rotate/browser/Options/Classes/RotateAnimation.js

class RotateAnimation {
    constructor() {
        this.enable = false;
        this.speed = 0;
        this.decay = 0;
        this.sync = false;
    }
    load(data) {
        if ((0,engine_root_window_.isNull)(data)) {
            return;
        }
        if (data.enable !== undefined) {
            this.enable = data.enable;
        }
        if (data.speed !== undefined) {
            this.speed = (0,engine_root_window_.setRangeValue)(data.speed);
        }
        if (data.decay !== undefined) {
            this.decay = (0,engine_root_window_.setRangeValue)(data.decay);
        }
        if (data.sync !== undefined) {
            this.sync = data.sync;
        }
    }
}

;// CONCATENATED MODULE: ../../node_modules/.pnpm/@tsparticles+updater-rotate@3.7.1/node_modules/@tsparticles/updater-rotate/browser/Options/Classes/Rotate.js


class Rotate extends engine_root_window_.ValueWithRandom {
    constructor() {
        super();
        this.animation = new RotateAnimation();
        this.direction = engine_root_window_.RotateDirection.clockwise;
        this.path = false;
        this.value = 0;
    }
    load(data) {
        if ((0,engine_root_window_.isNull)(data)) {
            return;
        }
        super.load(data);
        if (data.direction !== undefined) {
            this.direction = data.direction;
        }
        this.animation.load(data.animation);
        if (data.path !== undefined) {
            this.path = data.path;
        }
    }
}

;// CONCATENATED MODULE: ../../node_modules/.pnpm/@tsparticles+updater-rotate@3.7.1/node_modules/@tsparticles/updater-rotate/browser/RotateUpdater.js


const RotateUpdater_double = 2, doublePI = Math.PI * RotateUpdater_double, identity = 1, doublePIDeg = 360;
class RotateUpdater {
    constructor(container) {
        this.container = container;
    }
    init(particle) {
        const rotateOptions = particle.options.rotate;
        if (!rotateOptions) {
            return;
        }
        particle.rotate = {
            enable: rotateOptions.animation.enable,
            value: (0,engine_root_window_.degToRad)((0,engine_root_window_.getRangeValue)(rotateOptions.value)),
            min: 0,
            max: doublePI,
        };
        particle.pathRotation = rotateOptions.path;
        let rotateDirection = rotateOptions.direction;
        if (rotateDirection === engine_root_window_.RotateDirection.random) {
            const index = Math.floor((0,engine_root_window_.getRandom)() * RotateUpdater_double), minIndex = 0;
            rotateDirection = index > minIndex ? engine_root_window_.RotateDirection.counterClockwise : engine_root_window_.RotateDirection.clockwise;
        }
        switch (rotateDirection) {
            case engine_root_window_.RotateDirection.counterClockwise:
            case "counterClockwise":
                particle.rotate.status = engine_root_window_.AnimationStatus.decreasing;
                break;
            case engine_root_window_.RotateDirection.clockwise:
                particle.rotate.status = engine_root_window_.AnimationStatus.increasing;
                break;
        }
        const rotateAnimation = rotateOptions.animation;
        if (rotateAnimation.enable) {
            particle.rotate.decay = identity - (0,engine_root_window_.getRangeValue)(rotateAnimation.decay);
            particle.rotate.velocity =
                ((0,engine_root_window_.getRangeValue)(rotateAnimation.speed) / doublePIDeg) * this.container.retina.reduceFactor;
            if (!rotateAnimation.sync) {
                particle.rotate.velocity *= (0,engine_root_window_.getRandom)();
            }
        }
        particle.rotation = particle.rotate.value;
    }
    isEnabled(particle) {
        const rotate = particle.options.rotate;
        if (!rotate) {
            return false;
        }
        return !particle.destroyed && !particle.spawning && (!!rotate.value || rotate.animation.enable || rotate.path);
    }
    loadOptions(options, ...sources) {
        if (!options.rotate) {
            options.rotate = new Rotate();
        }
        for (const source of sources) {
            options.rotate.load(source?.rotate);
        }
    }
    update(particle, delta) {
        if (!this.isEnabled(particle)) {
            return;
        }
        particle.isRotating = !!particle.rotate;
        if (!particle.rotate) {
            return;
        }
        (0,engine_root_window_.updateAnimation)(particle, particle.rotate, false, engine_root_window_.DestroyType.none, delta);
        particle.rotation = particle.rotate.value;
    }
}

;// CONCATENATED MODULE: ../../node_modules/.pnpm/@tsparticles+updater-rotate@3.7.1/node_modules/@tsparticles/updater-rotate/browser/index.js


async function loadRotateUpdater(engine, refresh = true) {
    (0,engine_root_window_.assertValidVersion)(engine, "3.7.1");
    await engine.addParticleUpdater("rotate", container => {
        return Promise.resolve(new RotateUpdater(container));
    }, refresh);
}

// EXTERNAL MODULE: external {"commonjs":"@tsparticles/updater-size","commonjs2":"@tsparticles/updater-size","amd":"@tsparticles/updater-size","root":"window"}
var updater_size_root_window_ = __webpack_require__(2);
// EXTERNAL MODULE: external {"commonjs":"@tsparticles/shape-square","commonjs2":"@tsparticles/shape-square","amd":"@tsparticles/shape-square","root":"window"}
var shape_square_root_window_ = __webpack_require__(652);
// EXTERNAL MODULE: external {"commonjs":"@tsparticles/updater-stroke-color","commonjs2":"@tsparticles/updater-stroke-color","amd":"@tsparticles/updater-stroke-color","root":"window"}
var updater_stroke_color_root_window_ = __webpack_require__(204);
;// CONCATENATED MODULE: ./dist/browser/options.js

const options = {
  particles: {
    stroke: {
      width: 5,
      color: {
        value: ["#5bc0eb", "#fde74c", "#9bc53d", "#e55934", "#fa7921", "#2FF3E0", "#F8D210", "#FA26A0", "#F51720"]
      }
    },
    shape: {
      type: "square",
      options: {
        square: {
          fill: false
        }
      }
    },
    rotate: {
      value: 0,
      direction: engine_root_window_.RotateDirection.counterClockwise,
      animation: {
        enable: true,
        speed: 2,
        sync: true
      }
    },
    size: {
      value: {
        min: 1,
        max: 500
      },
      animation: {
        enable: true,
        startValue: engine_root_window_.StartValueType.min,
        speed: 60,
        sync: true,
        destroy: engine_root_window_.DestroyType.max
      }
    }
  },
  background: {
    color: "#000"
  },
  emitters: {
    position: {
      y: 50,
      x: 50
    },
    rate: {
      delay: 1,
      quantity: 1
    }
  }
};
;// CONCATENATED MODULE: ./dist/browser/index.js







async function loadSquaresPreset(engine, refresh = true) {
  await loadHexColorPlugin(engine, false);
  await (0,plugin_emitters_root_window_.loadEmittersPlugin)(engine, false);
  await (0,shape_square_root_window_.loadSquareShape)(engine, false);
  await loadRotateUpdater(engine, false);
  await (0,updater_size_root_window_.loadSizeUpdater)(engine, false);
  await (0,updater_stroke_color_root_window_.loadStrokeColorUpdater)(engine, false);
  await engine.addPreset("squares", options, false);
  await engine.refresh(refresh);
}
})();

/******/ 	return __webpack_exports__;
/******/ })()
;
});